#include "input.cpp"
#include "synthesize.cpp"
#include "classify.cpp"
#include "output.cpp"

int main(int argc, char* argv[]){

        // check the number of arguments passed to main
        if( argc<2 || 3<argc ){
           cout << "Program usage:"<<endl;
           cout << argv[0] << " [File] (parameter)"<<endl<<endl;
           cout << "[File] describes the following data files needed in the same directory:"<<endl<<endl;
           cout << "File.poi \t describes the polytope through its vertices." << endl;
           cout << "File.poi.ieq \t describes the polytope through its facets." << endl;
           cout << "File.huh \t describes symmetries of the polytope through affine maps." << endl<<endl;

           cout << "Optionally, one of the following parameters may be added:"<<endl<<endl;
           cout << "rep \t\t to only store representative inequalities."<<endl;
           cout << "closed \t\t if the maps in File.huh are closed under composition."<<endl;
           cout << "repclosed \t to use both parameters 'rep' and 'closed'."<<endl<<endl;

           cout << "The results will be stored in 'File.huhfa'."<<endl;
           return -1;
        }
        else{
            bool rep=false;
            bool complete=false;
            // store and convert data
            string File = argv[1];
            if(argc==3){
                string stringbuff = argv[2];
                rep=(stringbuff=="rep" || stringbuff=="repclosed");
                complete=(stringbuff=="closed" || stringbuff=="repclosed");
                if(stringbuff!="rep" && stringbuff!="closed" && stringbuff!="repclosed"){
                    cout<<"Warning: "<<stringbuff<<" is not a feasible parameter."<<endl;
                    cout<<"Proceeding with standard settings."<<endl;
                }
            }
            huhfa polytop(File);
            polytop.synthesize();
            polytop.classify(complete);
            polytop.output(File,rep);
            return 0;
        }
}

